/*
 *  file: trav.c implements recursive subdir/file walk-thru.
 */
#include	<conio.h>
#include	<ctype.h>
#include	<dir.h>
#include	<dos.h>
#include	<process.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

#define MAXCMD 300

char your_command[MAXCMD];
char initial_dir[MAXCMD];

int	do_trav(void);


void 
main(int argc, char *argv[])
{
    int subdirs, ar, resp, abrt;

    cprintf("TRAV by M.Garvin:  Traverses directory trees,"
		" issuing user-specified command\n\r");
    your_command[0] = '\0';
    if (argc < 2) {
	cprintf("No argument specified: No commands will be executed.\n\r");
    } else {
	/*
	 *  Check for potentially dangerous commands.
	 */
	abrt = 0;
	if (!stricmp(argv[1], "del") && !stricmp(argv[2], "*.*"))
	    abrt = 1;
	else if (!stricmp(argv[1], "md") || !stricmp(argv[1], "mkdir"))
	    abrt = 1;
	/*
	 *  Copy command line args into string to be sent to 'system()'.
	 */
	for (ar = 1; ar < argc; ar++) {
	    strcat(your_command, argv[ar]);
	    if (ar < argc - 1)
		strcat(your_command, " "); /* leave space between args	    */
	}
	if (abrt) {			/* avoid nasty commands		    */
	    printf("Sorry... Can't let you do it.\n");
	    printf("You were really going to run '%s' ?\n", your_command);
	    printf("Please consider what would occur if you"
			" ran this in all directories.\n");
	    return;
	}
	cprintf("Command to be sent to all subdirs"
		" within this directory:\n\r");
	cprintf("  %s\n\r", your_command);
	while (1) {
	    cprintf("Go ahead? (Y to exec, N or ESC to cancel): ");
	    resp = tolower(getch());
	    cprintf("%c\n\r", resp);
	    if (resp == 'y')
		break;
	    if (resp == 'n' || resp == 27)
		return;
	}
    }
    getcwd(initial_dir, MAXCMD);
    subdirs = do_trav();		/* one call starts recursive walk   */
    printf("\nTotal subdirs: %d\n", subdirs);
    chdir(initial_dir);
}


/*
 *  do_trav returns 1 if a directory or file was located, else 0.
 *   Calls itself if the encountered item is a directory.
 *   Returns the number of subdirs found.
 */
int
do_trav(void)
{
    int subdirs;
    struct ffblk fblock, saveblock;
    /*
     *  Exec dos command at current dir location.
     */
    subdirs = 0;
    if (your_command[0])
	if (system(your_command))
	    printf("\nError executing \"%s\"", your_command);
    /*
     *  Walk thru all files/subdirs in current path.
     */
    if (!findfirst("*.*", &fblock, FA_DIREC)) {
	do {
	    if ((fblock.ff_attrib & FA_DIREC) && strcmp(fblock.ff_name, ".")
			&& strcmp(fblock.ff_name, "..")) {
		/*
		 *  Found a subdirectory:  descend into it.
		 */
		++subdirs;
		saveblock = fblock;	/* save current dir structure	    */
		printf("\nProcessing dir: %s\n", fblock.ff_name);
		chdir(fblock.ff_name);
		subdirs += do_trav();	/* recursive walk thru new subdir   */
		fblock = saveblock;	/* back to where we were	    */
		chdir("..");
	    }
	} while (!findnext(&fblock));
    }
    return(subdirs);
}
